<?php

class ControllerExtensionPaymentuspay extends Controller{

  private $error = array();
  
  public function index(){

    $this->load->language('extension/payment/uspay');
    $this->document->setTitle($this->language->get('heading_title'));
    $this->load->model('setting/setting');
		
    if(($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()){

      $this->model_setting_setting->editSetting('payment_uspay', $this->request->post);
      $this->session->data['success'] = $this->language->get('text_success');
      $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));

    }

    $data['heading_title'] = $this->language->get('heading_title');
	
    $data['text_all_zones'] = $this->language->get('text_all_zones');
    $data['text_payment'] = $this->language->get('text_payment');
    $data['text_success'] = $this->language->get('text_success');
    $data['text_edit'] = $this->language->get('text_edit');
    $data['text_pay'] = $this->language->get('text_pay');
    $data['text_enabled'] = $this->language->get('text_enabled');
    $data['text_disabled'] = $this->language->get('text_disabled');
    $data['text_uspay'] = $this->language->get('text_uspay');
    $data['text_email_subject'] = $this->language->get('text_email_subject');
    $data['text_email_message1'] = $this->language->get('text_email_message1');
    $data['text_email_message2'] = $this->language->get('text_email_message2');
    $data['text_email_message3'] = $this->language->get('text_email_message3');
    $data['text_email_message4'] = $this->language->get('text_email_message4');
    $data['text_email_message5'] = $this->language->get('text_email_message5');
    $data['text_email_message6'] = $this->language->get('text_email_message6');
		
    $data['entry_url'] = $this->language->get('entry_url');
    $data['entry_merchant'] = $this->language->get('entry_merchant');
    $data['entry_security'] = $this->language->get('entry_security');
    $data['entry_order_wait'] = $this->language->get('entry_order_wait');
    $data['entry_order_success'] = $this->language->get('entry_order_success');
    $data['entry_order_fail'] = $this->language->get('entry_order_fail');
    $data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
    $data['entry_status'] = $this->language->get('entry_status');
    $data['entry_sort_order'] = $this->language->get('entry_sort_order');
    $data['entry_log'] = $this->language->get('entry_log');
    $data['entry_list_ip'] = $this->language->get('entry_list_ip');
    $data['entry_admin_email'] = $this->language->get('entry_admin_email');
    $data['entry_merchant'] = $this->language->get('entry_merchant');
    $data['entry_status_url'] = $this->language->get('entry_status_url');
    $data['entry_success_url'] = $this->language->get('entry_success_url');
    $data['entry_fail_url'] = $this->language->get('entry_fail_url');
    $data['entry_debug'] = $this->language->get('entry_debug');
    $data['entry_debug_off'] = $this->language->get('entry_debug_off');
    $data['entry_debug_on'] = $this->language->get('entry_debug_on');

    $data['error_url'] = $this->language->get('error_url');
    $data['error_permission'] = $this->language->get('error_permission');
    $data['error_merchant'] = $this->language->get('error_merchant');
    $data['error_security'] = $this->language->get('error_security');

    $data['help_url'] = $this->language->get('help_url');
    $data['help_merchant'] = $this->language->get('help_merchant');
    $data['help_security'] = $this->language->get('help_security');
    $data['help_log'] = $this->language->get('help_log');
    $data['help_list_ip'] = $this->language->get('help_list_ip');
    $data['help_admin_email'] = $this->language->get('help_admin_email');
    $data['help_debug'] = $this->language->get('help_debug');

    $data['button_save'] = $this->language->get('button_save');
    $data['button_cancel'] = $this->language->get('button_cancel');

    $data['selected_debug_0'] = $data['selected_debug_1'] = '';
    $data['selected_debug_' . $this->config->get('payment_uspay_debug')] = 'selected';

    $data['error_warning'] = isset($this->error['warning']) ? $this->error['warning'] : '';
    $data['error_url'] = isset($this->error['url']) ? $this->error['url'] : '';
    $data['error_merchant'] = isset($this->error['merchant']) ? $this->error['merchant'] : '';
    $data['error_security'] = isset($this->error['security']) ? $this->error['security'] : '';
    $data['error_type'] = isset($this->error['type']) ? $this->error['type'] : '';

    $data['breadcrumbs'] = array(
      array(
        'text' => $this->language->get('text_home'),
        'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
      ),
      array(
        'text' => $this->language->get('text_payment'),
        'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
      ),
	  array(
	    'text' => $this->language->get('heading_title'),
		'href' => $this->url->link('extension/payment/uspay', 'user_token=' . $this->session->data['user_token'], true)
	  )
	);

	$data['action'] = $this->url->link('extension/payment/uspay', 'user_token=' . $this->session->data['user_token'], true);
	$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

	$data['payment_uspay_url'] = isset($this->request->post['payment_uspay_url']) ? $this->request->post['payment_uspay_url'] : ( !$this->config->get('payment_uspay_url') ? 'https://uspay.ru/merchant' : $this->config->get('payment_uspay_url') );
	$data['payment_uspay_merchant'] = isset($this->request->post['payment_uspay_merchant']) ? $this->request->post['payment_uspay_merchant'] : $this->config->get('payment_uspay_merchant');
	$data['payment_uspay_security'] = isset($this->request->post['payment_uspay_security']) ? $this->request->post['payment_uspay_security'] : $this->config->get('payment_uspay_security');
	$data['payment_uspay_debug'] = isset($this->request->post['payment_uspay_debug']) ? $this->request->post['payment_uspay_debug'] : $this->config->get('payment_uspay_debug');
	$data['payment_uspay_sort_order'] = isset($this->request->post['payment_uspay_sort_order']) ? $this->request->post['payment_uspay_sort_order'] : $this->config->get('payment_uspay_sort_order');
	$data['payment_uspay_order_wait_id'] = isset($this->request->post['payment_uspay_order_wait_id']) ? $this->request->post['payment_uspay_order_wait_id'] : ( !$this->config->get('payment_uspay_order_wait_id') ? 1 : $this->config->get('payment_uspay_order_wait_id') );
	$data['payment_uspay_order_success_id'] = isset($this->request->post['payment_uspay_order_success_id']) ? $this->request->post['payment_uspay_order_success_id'] : ( !$this->config->get('payment_uspay_order_success_id') ? 2 : $this->config->get('payment_uspay_order_success_id') );
	$data['payment_uspay_order_fail_id'] = isset($this->request->post['payment_uspay_order_fail_id']) ? $this->request->post['payment_uspay_order_fail_id'] : ( !$this->config->get('payment_uspay_order_fail_id') ? 10 : $this->config->get('payment_uspay_order_fail_id') );

	$this->load->model('localisation/order_status');

	$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
	$data['payment_uspay_geo_zone_id'] = isset($this->request->post['payment_uspay_geo_zone_id']) ? $this->request->post['payment_uspay_geo_zone_id'] : $this->config->get('payment_uspay_geo_zone_id');

	$this->load->model('localisation/geo_zone');

	$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
	$data['payment_uspay_status'] = isset($this->request->post['payment_uspay_status']) ? $this->request->post['payment_uspay_status'] : $this->config->get('payment_uspay_status');
	$data['payment_uspay_sort_order'] = isset($this->request->post['payment_uspay_sort_order']) ? $this->request->post['payment_uspay_sort_order'] : $this->config->get('payment_uspay_sort_order');
	$data['payment_uspay_log_value'] = isset($this->request->post['payment_uspay_log_value']) ? $this->request->post['payment_uspay_log_value'] : $this->config->get('payment_uspay_log_value');
	$data['payment_uspay_list_ip'] = isset($this->request->post['payment_uspay_list_ip']) ? $this->request->post['payment_uspay_list_ip'] : $this->config->get('payment_uspay_list_ip');
	$data['payment_uspay_admin_email'] = isset($this->request->post['payment_uspay_admin_email']) ? $this->request->post['payment_uspay_admin_email'] : $this->config->get('payment_uspay_admin_email');

	$data['header'] = $this->load->controller('common/header');
	$data['column_left'] = $this->load->controller('common/column_left');
	$data['footer'] = $this->load->controller('common/footer');

	$this->response->setOutput($this->load->view('extension/payment/uspay', $data));

  }

  protected function validate(){

    if(!$this->user->hasPermission('modify', 'extension/payment/uspay')){

      $this->error['warning'] = $this->language->get('error_permission');

    }

    if(!$this->request->post['payment_uspay_url']){

      $this->error['url'] = $this->language->get('error_url');

    }

    if(!$this->request->post['payment_uspay_merchant']){

      $this->error['merchant'] = $this->language->get('error_merchant');

    }

    if(!$this->request->post['payment_uspay_security']){

      $this->error['security'] = $this->language->get('error_security');

    }

    return !$this->error;

  }

}