<?php

class ControllerExtensionPaymentUspay extends Controller{	

  public function index(){

	$this->load->model('checkout/order');

    $security = $this->config->get('payment_uspay_security');
    $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
	
    $data['shop_id'] = $this->config->get('payment_uspay_merchant');
    $data['amount'] = number_format((float) $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false), 2, '.', '');
    $data['description'] = base64_encode('Заказ №' . $this->session->data['order_id']);
    $data['order_id'] = $this->session->data['order_id'];
    $data['method'] = '';
	$hash = hash('sha256', $data['shop_id'].$data['amount'].$security.$data['order_id']);
    $data['signature'] = $hash;
	
    $data['action'] = $this->config->get('payment_uspay_url');
    $data['button_confirm'] = $this->language->get('button_confirm');

	$this->model_checkout_order->addOrderHistory($data['order_id'], $this->config->get('payment_uspay_order_wait_id'));
	
	return $this->load->view('extension/payment/uspay', $data);

  }
  
  public function status(){

    $request = $this->request->post;
	
	if(isset($request["label"])){

      $err = false;
      $message = '';

      $this->load->language('extension/payment/uspay');
	  $hash = hash('sha256', $request['shop_id'].$request['amount'].$this->config->get('payment_uspay_security').$request['pay']);
	  
			
      $log_text = "--------------------------------------------------------\n" .
	              "id					" . $request['label'] . "\n" .
				  "amount 				" . $request['amount'] . "\n" .
				  "hash 				" . $request['hash'] . "\n" .
				  

      $log_file = $this->config->get('payment_uspay_log_value');

      if(!empty($log_file)){
		
		$log_file = $_SERVER['DOCUMENT_ROOT'] . '/' . $log_file;

        if(file_exists($log_file)){

          file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/' . $log_file, $log_text, FILE_APPEND);
		
		}

      }

      $valid_ip = true;
      $sIP = str_replace(' ', '', $this->config->get('payment_uspay_list_ip'));
			
      if(!empty($sIP)){

        $arrIP = explode('.', $_SERVER['REMOTE_ADDR']);
		
		if(!preg_match('/(^|,)(' . $arrIP[0] . '|\*{1})(\.)' . '(' . $arrIP[1] . '|\*{1})(\.)' . '(' . $arrIP[2] . '|\*{1})(\.)' . '(' . $arrIP[3] . '|\*{1})($|,)/', $sIP)){

          $valid_ip = false;
		
		}
		
	  }
	  
	  if(!$valid_ip){
	
	    $message .= $this->language->get('text_email_message4') . "\n" . $this->language->get('text_email_message5') . $sIP . "\n" . $this->language->get('text_email_message6') . $_SERVER['REMOTE_ADDR'] . "\n";
		
		$err = true;

      }
	  
	  if($request['hash'] != $hash){

        $message .= $this->language->get('text_email_message2') . "\n";
		
		$err = true;

      }
	  
	  if(!$err){

        // загрузка заказа
				
        $this->load->model('checkout/order');
        $order = $this->model_checkout_order->getOrder($request['label']);
		
		if(!$order){
		
		  $message .= $this->language->get('text_email_message9') . "\n";
		  
		  $err = true;
		
		}else{
		
		  $order_curr = $order['currency_code'] == 'RUR' ? 'RUB' : $order['currency_code'];
		  $order_amount = number_format($order['total'], 2, '.', '');
		  
		  // проверка суммы и валюты
		  
		  if($request['amount'] != $order_amount){

            $message .= $this->language->get('text_email_message7') . " \n";
			$message .= 'amount = ' . $request['amount'] . ' order_amount = '. $order_amount;
			
			$err = true;
		
		  }
		  
		  if($request['currency'] != $order_curr){
		
		    $message .= $this->language->get('text_email_message8') . " currency\n";
			$err = true;
		
		  }
		  
		  // проверка статуса
		  
		  if(!$err){
		
		    switch($request['status']){
			
			  case 'success':
			  
			    if($order['order_status_id'] !== $this->config->get('payment_uspay_order_success_id')){
				
				  $this->model_checkout_order->addOrderHistory($request['order_id'], $this->config->get('payment_uspay_order_success_id'));
				  
				  $message .=  "order_status_id = " . $order['order_status_id'] . " mega = ".$this->config->get('payment_uspay_order_success_id');
				
				}
				
				break;
				
			  default:
				
				$message .= $this->language->get('text_email_message3') . "\n";
				  
				$this->model_checkout_order->addOrderHistory($request['order_id'], $this->config->get('payeer_order_fail_id'));
				  
				$err = true;
				
			    break;
			
		    }

		  }

		}

      }
	  
	  $data['order_id'] = $request['order_id'];
	  
	  if($err){
	
	    $data['order_status'] = 'error';
		$to = $this->config->get('payment_uspay_admin_email');
		
		if(!empty($to)){
		
		  $message = $this->language->get('text_email_message1');
		  $headers = "From: no-reply@" . $_SERVER['HTTP_HOST'] . "\r\n" . "Content-type: text/plain; charset=utf-8 \r\n";
		
		  mail($to, $this->language->get('text_email_subject'), $message, $headers);
		
		}
	  
	    $this->response->setOutput($message);
	
	  }else{
	
	    $data['order_status'] = 'success';
	  
	    $this->response->setOutput('ok');
	
	  }
	
	}

  }

  public function fail(){

    $this->response->redirect($this->url->link('checkout/checkout'));	

    return true;

  }

  public function success(){

    $this->response->redirect($this->url->link('checkout/success'));

    return true;

  }

}